Attribute VB_Name = "Module01_GenAllTPI_14"
Sub GenAllTPI_14()
Attribute GenAllTPI_14.VB_Description = "Ctrl+Shift+G   Generates AllTPI sheet using 14 columns of gears"
Attribute GenAllTPI_14.VB_ProcData.VB_Invoke_Func = "G\n14"
'
'Ctrl+Shift+G   Generates AllTPI sheet using 14 columns of gears
'Predefines the Column number as letters to increase speed ... slightly.
'Deletes all old sheets except sheets starting with uw... such as uwPM1440GT

Dim MyLathe As String
Dim Test As Integer
Dim Statusinfo As String
Dim tmpL As String  ' left letter of a string
Dim tmpR As String  ' right letter of a string
'The shorthand for the types is: % -integer; & -long; @ -currency; # -double; ! -single; $ -string
Dim SRow As Integer, SCol As Integer
Dim RowNum1%, RowNum2%, RowNum3%, RowNum4%, RowNum5%, RowNum6%, RowNum7 As Integer
Dim ColNum1%, ColNum2%, ColNum3%, ColNum4%, ColNum5%, ColNum6%, ColNum7%, ColNum8 As Integer
Dim ColLet1$, ColLet2$, ColLet3$, ColLet4$, ColLet5$, ColLet6$, ColLet7 As String
Dim MaxCnt As Double  ' check to ensure on error has occured
Dim WFalse As Integer

    MsgStr = "Please Type your Lathe Model gear sheet.  Examples: uwPM1440GT, uwPM1340GT or other future gear built sheets."
        MyLathe = InputBox(MsgStr, _
            "Provide your lathe Sheet Tab Name", "Your Lathe Spread Sheet name goes here")
    If MyLathe = "False" Or Len(Trim(MyLathe)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
    
    Test = False
    For Each Sheet In ActiveWorkbook.Worksheets  ' this checks for existance of lathe model
        If Sheet.Name = MyLathe Then
            Sheets(MyLathe).Select
            Test = True
            Else
        End If
    Next Sheet

    If Not Test Then
       MsgBox "There is no Lathe Model by the name:  " & MyLathe
        Exit Sub
    End If
       
Application.StatusBar = "Macro Task Initiated First Delete Old sheets and then Create a new one- please wait"
Application.DisplayAlerts = False ' This turns off=False notation of the sheet deletion
'  This deletes all sheets which either do not start with uw
'  i.e. this keeps all "uw" starting and "T" ending sheets
' Currently there are no sheet which end in a "T"

For Each Sheet In ActiveWorkbook.Worksheets
    tmpL = Left(Sheet.Name, 2)
    tmpR = Right(Sheet.Name, 1)
    If tmpL = "uw" Then
        ElseIf tmpR = "T" Then
        Else: Sheet.Delete
    End If
Next Sheet
'Application.DisplayAlerts = True
'
Sheets.Add(Before:=Sheets(1)).Name = "AllTPI" 'create sheet and place at first tab position
Sheets("AllTPI").Select

'First, Get retrieve and place locations for generated data from the MyLathe sheet being used
Sheets(MyLathe).Select
SRow = Cells(1, 1).Value - 1    'Titles at row #21
SCol = Cells(2, 1).Value - 1    '2-1==> Column A
RowNum1 = Cells(SRow + 1, SCol + 1).Value '112
RowNum2 = Cells(SRow + 2, SCol + 1).Value '113
RowNum3 = Cells(SRow + 3, SCol + 1).Value '24
RowNum4 = Cells(SRow + 4, SCol + 1).Value '30
'RowNum5 = Cells(SRow + 5, SCol + 1).Value    'TBD if ever needed
'RowNum6 = Cells(SRow + 6, SCol + 1).Value    'TBD if ever needed
RowNum7 = Cells(SRow + 7, SCol + 1).Value  '10 = 'MaxCnt variable to limit the length of a run if need be

ColNum1 = Cells(SRow + 1, SCol + 2).Value
ColNum2 = Cells(SRow + 2, SCol + 2).Value
ColNum3 = Cells(SRow + 3, SCol + 2).Value
ColNum4 = Cells(SRow + 4, SCol + 2).Value
ColNum5 = Cells(SRow + 5, SCol + 2).Value
ColNum6 = Cells(SRow + 6, SCol + 2).Value
ColNum7 = Cells(SRow + 7, SCol + 2).Value

ColLet1 = Chr(ColNum1 + 64)
ColLet2 = Chr(ColNum2 + 64)
ColLet3 = Chr(ColNum3 + 64)
ColLet4 = Chr(ColNum4 + 64)
ColLet5 = Chr(ColNum5 + 64)
ColLet6 = Chr(ColNum6 + 64)
ColLet7 = Chr(ColNum7 + 64)

Dim ColNum400%, ColNum401%, ColNum402%, ColNum403%, ColNum404%, ColNum405%, ColNum406%, ColNum407 As Integer
Dim ColNum408%, ColNum409%, ColNum410%, ColNum411%, ColNum412%, ColNum413%, ColNum414  As Integer
Dim ColLet400$, ColLet401$, ColLet402$, ColLet403$, ColLet404$, ColLet405$, ColLet406, ColLet407 As String
Dim ColLet408$, ColLet409$, ColLet410$, ColLet411$, ColLet412$, ColLet413$, ColLet414 As String
ColNum400 = ColNum4 + 0
ColNum401 = ColNum4 + 1
ColNum402 = ColNum4 + 2
ColNum403 = ColNum4 + 3
ColNum404 = ColNum4 + 4
ColNum405 = ColNum4 + 5
ColNum406 = ColNum4 + 6
ColNum407 = ColNum4 + 7
ColNum408 = ColNum4 + 8
ColNum409 = ColNum4 + 9
ColNum410 = ColNum4 + 10
ColNum411 = ColNum4 + 11
ColNum412 = ColNum4 + 12
ColNum413 = ColNum4 + 13
ColNum414 = ColNum4 + 14

ColLet400 = Chr(ColNum400 + 64)
ColLet401 = Chr(ColNum401 + 64)
ColLet402 = Chr(ColNum402 + 64)
ColLet403 = Chr(ColNum403 + 64)
ColLet404 = Chr(ColNum404 + 64)
ColLet405 = Chr(ColNum405 + 64)
ColLet406 = Chr(ColNum406 + 64)
ColLet407 = Chr(ColNum407 + 64)
ColLet408 = Chr(ColNum408 + 64)
ColLet409 = Chr(ColNum409 + 64)
ColLet410 = Chr(ColNum410 + 64)
ColLet411 = Chr(ColNum411 + 64)
ColLet412 = Chr(ColNum412 + 64)
ColLet413 = Chr(ColNum413 + 64)
ColLet414 = Chr(ColNum414 + 64)

' Need a check on the looping to prevent the process from going on too long,i.e. user put in too many gears
' The MaxCnt check will be located put inside the loops and increase 8x each time it is rejected by the user
MaxCnt = RowNum7 ' Initial value, but this value will increase if allowed to do so.
If MaxCnt <= 0 Then MaxCnt = 128

'Set the column widths & formats of table being generated
Sheets("AllTPI").Select

'Columns("A:Z").ColumnWidth = 8  ' All columns
Columns(ColLet1 & ":" & ColLet7).ColumnWidth = 8 'works to set column width S based upon MyLathe values
'Columns("A:B").ColumnWidth = 5  'counters at left
Columns(ColLet1 & ":" & Chr(ColNum1 + 64 + 1)).ColumnWidth = 5  ' Row and line numbers
Columns(ColLet4 & ":" & Chr(ColNum6 + 64 - 3)).ColumnWidth = 6 'the gear numbers and knobs

Columns(Chr(ColNum4 + 64 - 1)).ColumnWidth = 6  'The first column in the table could be different
Columns(Chr(ColNum3 + 64 + 2)).Borders(xlEdgeRight).LineStyle = xlDouble 'vertical double line edge at last cell of English data value
Columns(Chr(ColNum6 + 64 - 1)).ColumnWidth = 6  ' The last column in the table could be different
Columns(Chr(ColNum6 + 64 - 2)).Borders(xlEdgeLeft).LineStyle = xlDouble 'vertical double line edge at first cell of Metric data value

Columns(ColLet2 & ":" & ColLet7).NumberFormat = "0.00000"  ' all but the first two column - counters-- then change some back
Columns(Chr(ColNum5 + 64 - 1) & ":" & Chr(ColNum6 + 64 - 3)).NumberFormat = "0" ' the exchange gear columns (teeth, not gear box)
Columns(ColLet1 & ":" & ColLet7).HorizontalAlignment = xlCenter 'center txt for all columns

Range("A2").NumberFormat = "0"  ' upper left corner of table= total number of gear settings generate

' Copy-Paste two header lines, CopyColTitles, from Lathe sheet to AllTPI
Sheets(MyLathe).Select
Range(ColLet1 & RowNum1, ColLet7 & RowNum2).Select  ' select and copy the two title_header rows
Selection.Copy
Worksheets("AllTPI").Select
ActiveSheet.Range("A1").Select  'Home is the first paste entry location for titles
Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
    :=False, Transpose:=False
'  Place a double line under the titles
Range("A2", ColLet7 & 2).Borders(xlEdgeBottom).LineStyle = xlDouble

Application.StatusBar = "New Sheet Constructed, now initiating parameters - please wait"

'  More Dim statements here
Dim LineCount As Long, GearRowCnt As Long
LineCount = 4  ' number of rows/lines in the spread sheet of computed data, Initial spread sheet row corresponding to the line count.
GearRowCnt = 1  ' number of rows of data, initial value=1
Sheets(MyLathe).Select
'Use the row numbers where data is temporarily stored at the bottom of MyLathe sheet
Worksheets(MyLathe).Range(ColLet1 & RowNum2 + 1) = LineCount 'bottom of MyLathe sheet
Worksheets(MyLathe).Range(Chr(ColNum1 + 64 + 1) & RowNum2 + 1) = GearRowCnt  ' second column contains the gear row count #

'Dimension some running ranges used to select the gear values at the pull down menus.
'The shorthand for the types is: % -integer; & -long; @ -currency; # -double; ! -single; $ -string
Dim dvCeli As Range, dvCelj As Range, dvCelk As Range, dvCell As Range, dvCelm As Range, dvCeln As Range, dvCelo As Range, dvCelp As Range, dvCelq As Range, dvCelr As Range, dvCels As Range, dvCelt As Range, dvCelu As Range, dvCelv As Range
Dim InputRi As Range, InputRj As Range, InputRk As Range, InputRl As Range, InputRm As Range, InputRn As Range, InputRo As Range, InputRp As Range, InputRq As Range, InputRr As Range, InputRs As Range, InputRt As Range, InputRu As Range, InputRv As Range
Dim Ri As Range, Rj As Range, Rk As Range, Rl As Range, Rm As Range, Rn As Range, Ro As Range, Rp As Range, Rq As Range, Rr As Range, Rs As Range, Rt As Range, Ru As Range, Rv As Range
Dim Ci&, Cj&, Ck&, Cl&, Cm&, Cn&, Co&, Cp&, Cq, Cr&, Cs&, Ct&, Cu&, Cv As Long
' Dim CiMax As Long

Worksheets(MyLathe).Select
' Define values as coming from the pull down menu Locations as ranges:
'Set dvCeli = Worksheets(MyLathe).Range("I30")  ' example Typical
Set dvCeli = Worksheets(MyLathe).Range(Chr(ColNum4 + 0 + 64) & RowNum4)    'I30
Set dvCelj = Worksheets(MyLathe).Range(Chr(ColNum4 + 1 + 64) & RowNum4)    'J30
Set dvCelk = Worksheets(MyLathe).Range(Chr(ColNum4 + 2 + 64) & RowNum4)    'K30
Set dvCell = Worksheets(MyLathe).Range(Chr(ColNum4 + 3 + 64) & RowNum4)    'L30
Set dvCelm = Worksheets(MyLathe).Range(Chr(ColNum4 + 4 + 64) & RowNum4)    'M30
Set dvCeln = Worksheets(MyLathe).Range(Chr(ColNum4 + 5 + 64) & RowNum4)    'N30
Set dvCelo = Worksheets(MyLathe).Range(Chr(ColNum4 + 6 + 64) & RowNum4)    'O30
Set dvCelp = Worksheets(MyLathe).Range(Chr(ColNum4 + 7 + 64) & RowNum4)    'P30
Set dvCelq = Worksheets(MyLathe).Range(Chr(ColNum4 + 8 + 64) & RowNum4)    'Q30
Set dvCelr = Worksheets(MyLathe).Range(Chr(ColNum4 + 9 + 64) & RowNum4)    'R30
Set dvCels = Worksheets(MyLathe).Range(Chr(ColNum4 + 10 + 64) & RowNum4)    'S30
Set dvCelt = Worksheets(MyLathe).Range(Chr(ColNum4 + 11 + 64) & RowNum4)    'T30
Set dvCelu = Worksheets(MyLathe).Range(Chr(ColNum4 + 12 + 64) & RowNum4)    'U30
Set dvCelv = Worksheets(MyLathe).Range(Chr(ColNum4 + 13 + 64) & RowNum4)    'V30
'
' Set Varibles as otained from the pull down formulas in the pull down menu cells
Set InputRi = Evaluate(dvCeli.Validation.Formula1)
Set InputRj = Evaluate(dvCelj.Validation.Formula1)
Set InputRk = Evaluate(dvCelk.Validation.Formula1)
Set InputRl = Evaluate(dvCell.Validation.Formula1)
Set InputRm = Evaluate(dvCelm.Validation.Formula1)
Set InputRn = Evaluate(dvCeln.Validation.Formula1)
Set InputRo = Evaluate(dvCelo.Validation.Formula1)
Set InputRp = Evaluate(dvCelp.Validation.Formula1)
Set InputRq = Evaluate(dvCelq.Validation.Formula1)
Set InputRr = Evaluate(dvCelr.Validation.Formula1)
Set InputRs = Evaluate(dvCels.Validation.Formula1)
Set InputRt = Evaluate(dvCelt.Validation.Formula1)
Set InputRu = Evaluate(dvCelu.Validation.Formula1)
Set InputRv = Evaluate(dvCelv.Validation.Formula1)

' Initialize loop counters indices
Ci = 1
' CiMax = Ci 'line count for first gear to insert cell bottom lines every set of gears (NOT USED for anything, DELETE all References?)
Cj = 1
Ck = 1
Cl = 1
Cm = 1
Cn = 1
Co = 1
Cp = 1
Cq = 1
Cr = 1
Cs = 1
Ct = 1
Cu = 1
Cv = 1
'
' Before looping: Initiallize the values in the pull down menus to the first in the list
'   It is not clear that this is necessary, but it removes an possible history
'Worksheets(MyLathe).Cells(30, "I").Value = InputRi(1, 1) ' example
Worksheets(MyLathe).Select
Cells(RowNum4, ColNum4 + 0).Value = InputRi(1, 1) '(30,"I")=(30,9+0)
Cells(RowNum4, ColNum4 + 1).Value = InputRj(1, 1)
Cells(RowNum4, ColNum4 + 2).Value = InputRk(1, 1)
Cells(RowNum4, ColNum4 + 3).Value = InputRl(1, 1)
Cells(RowNum4, ColNum4 + 4).Value = InputRm(1, 1)
Cells(RowNum4, ColNum4 + 5).Value = InputRn(1, 1)
Cells(RowNum4, ColNum4 + 6).Value = InputRo(1, 1)
Cells(RowNum4, ColNum4 + 7).Value = InputRp(1, 1)  '(30,"P")=(30,9+7)
Cells(RowNum4, ColNum4 + 8).Value = InputRq(1, 1)
Cells(RowNum4, ColNum4 + 9).Value = InputRr(1, 1)
Cells(RowNum4, ColNum4 + 10).Value = InputRs(1, 1)
Cells(RowNum4, ColNum4 + 11).Value = InputRt(1, 1)
Cells(RowNum4, ColNum4 + 12).Value = InputRu(1, 1)
Cells(RowNum4, ColNum4 + 13).Value = InputRv(1, 1)  '(30,"V")=(30,9+13)=(30,22)

'Concept:  Nested loops for pull down menus, with indexing data count of the nummber of data Rows: "GearRowCnt".
'Loop until value = "Zzz" for first gear ratio
'Loop until value = "Zzz" for 2nd gear ratio
'Loop until value = "Zzz" for next gear or gear ratio, etc.
'Order the loops as to how the gears should be incremented in the table
'Repeat this until all gears and gear ratios are used.
'Increment LineCount and GearRowCnt
'Put LineCount & GearRowCnt in lathe sheet at row next to data for a set of gears.
' LineCount and Gear Row Count are usedful to have when sorting and searching the Table
'Begin our loops to work through all of the gear pull down menus

Application.ScreenUpdating = True  'Show the jump to the Sheet of the Table
Worksheets("AllTPI").Select
Application.ScreenUpdating = False  'If False then the screen does not refresh during execution.  Speed is Much better
Worksheets(MyLathe).Select

Application.StatusBar = "Starting the gear build - please wait"

WFalse = False  ' this logic is used to get out of the following loops if they number of them exceedss the preset, MaxCnt

Do While WFalse = False  ' This is a conditional function.  Ends with wend
' In this set of nested loops we
' Run through each of the gear pull down values.
' All Menus are many rows deep so the loops exit/stop when encountering the Zzz in the list.
' This sorts the results with the outer most loop repeating the less frequent.
'This is the FEED, then the 2x multiples in the gear box, then the gear box, then the ExternalGears

'********* Moved Feed/LeadScrew sequence order to the outer most loop so that..
' by putting FEED second on the pull down menu list all FEED threading values will be after the TPI
' This is the FEED-LEADScrew column loop Start
For Each Rm In InputRm  ' referenced as "m" since in the M column
        dvCelm = Rm.Value
        If Worksheets(MyLathe).Range(ColLet404 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

'*****Factors of 2, A-D etc, to next most outer most loop so as to first allow all gears to run through without
' changing the factor of two.  ************

' This is the A_D knob loop on the PM1440GT
For Each Rn In InputRn  ' "n" stands for the N column
        dvCeln = Rn.Value
        If Worksheets(MyLathe).Range(ColLet405 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

' Now increment the menus for the the the rest of the gear box and external gears.
' Work the loops from the spindle to the gear box ...
' The last  gear column is the Upper (spindle) Gear loop, the gear that drives the spindle
For Each Rv In InputRv   ' "v" outer most looping group is from column V, the top Spindle gear, Pull down Menu: "Spindle"
        dvCelv = Rv.Value
        If Worksheets(MyLathe).Range(Chr(ColNum4 + 13 + 64) & RowNum4).Value = "Zzz" Then
     Exit For
        End If

For Each Ru In InputRu   ' "u" ==>column U 'Pull down Menu: labled A2Spin
        dvCelu = Ru.Value
        If Worksheets(MyLathe).Range(ColLet412 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

For Each Rt In InputRt
        dvCelt = Rt.Value
        If Worksheets(MyLathe).Range(ColLet411 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

For Each Rs In InputRs
        dvCels = Rs.Value
        If Worksheets(MyLathe).Range(ColLet410 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

For Each Rr In InputRr
        dvCelr = Rr.Value
        If Worksheets(MyLathe).Range(ColLet409 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

For Each Rq In InputRq
        dvCelq = Rq.Value
        If Worksheets(MyLathe).Range(ColLet408 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

For Each Rp In InputRp   ' This is the C-C Exchange Gear loop
        dvCelp = Rp.Value
        If Worksheets(MyLathe).Range(ColLet407 & RowNum4).Value = "Zzz" Then
     Exit For
        End If
 
For Each Ro In InputRo  ' This is the Screw2C gear loop
        dvCelo = Ro.Value
        If Worksheets(MyLathe).Range(ColLet406 & RowNum4).Value = "Zzz" Then
     Exit For
        End If
' Finished the exchange gears.

'********** Moved A_D knob factors of 2 to second most outer loop
' Now drive the gear box.
' This is the Null loop
For Each Rl In InputRl
        dvCell = Rl.Value
        If Worksheets(MyLathe).Range(ColLet403 & RowNum4).Value = "Zzz" Then
     Exit For
        End If
        
 For Each Rk In InputRk
        dvCelk = Rk.Value
        If Worksheets(MyLathe).Range(ColLet402 & RowNum4).Value = "Zzz" Then
     Exit For
        End If
        
' This is the WXYZ lever loop, as labled on the PM1440GT, on some machines this is the doubling positions or a second Norton
For Each Rj In InputRj
        dvCelj = Rj.Value
        If Worksheets(MyLathe).Range(ColLet401 & RowNum4).Value = "Zzz" Then
     Exit For
        End If
        
' This is the PQRiT lever loop, as labled on the PM1440GT.  If Norton gear box, One, Two, etc.
For Each Ri In InputRi  ' inner most looping group is from column I, the first set of gear handles
        dvCeli = Ri.Value
        If Worksheets(MyLathe).Range(ColLet400 & RowNum4).Value = "Zzz" Then
     Exit For
        End If

' Organize the gear values into a single row structure at the bottom of the sheet.
        Worksheets(MyLathe).Select
'        Worksheets(MyLathe).Cells(112 - 1 + Ci, "I").Value = Worksheets(MyLathe).Range("I28").Value  '(Chr(ColNum4 + 0 + 64) & RowNum4)
        Cells(RowNum2 + Ci, ColNum4 + 0 - 1).Value = Range(ColLet400 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum400).Value = Range(ColLet401 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum401).Value = Range(ColLet402 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum402).Value = Range(ColLet403 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum403).Value = Range(ColLet404 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum404).Value = Range(ColLet405 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum405).Value = Range(ColLet406 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum406).Value = Range(ColLet407 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum407).Value = Range(ColLet408 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum408).Value = Range(ColLet409 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum409).Value = Range(ColLet410 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum410).Value = Range(ColLet411 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum411).Value = Range(ColLet412 & RowNum4).Value
        Cells(RowNum2 + Ci, ColNum412).Value = Range(ColLet413 & RowNum4).Value

'English Cells-- Copy TPI etc 5 rows of data into a single row of 5 columns, transpose, at the bottom of My lathe sheet to lelft of gear values
        Worksheets(MyLathe).Select
        Range(Cells(RowNum3, ColNum3), Cells(RowNum3 + 4, ColNum3)).Select
        Selection.Copy
        ActiveSheet.Range(ColLet2 & RowNum2 + Ci).Select
        Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
            SkipBlanks:=False, Transpose:=True
        Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
            :=False, Transpose:=True

'Metric Cells -- Copy mm/Thread etc 5 rows of data into a singe row of 5 columns, transpose, to right of the with gear values.
        Worksheets(MyLathe).Select
        Range(Cells(RowNum3, ColNum6), Cells(RowNum3 + 4, ColNum6)).Select
        Selection.Copy
        ActiveSheet.Range(Cells(RowNum2 + Ci, ColNum6 - 2), Cells(RowNum2 + Ci, ColNum6 - 2)).Select
'        ActiveSheet.Range(ColLet6 & RowNum2 + Ci).Select
        Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
            SkipBlanks:=False, Transpose:=True
        Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
            :=False, Transpose:=True

' Insert a LineCount and GearRowCnt at the left columns of MyLathe.
Worksheets(MyLathe).Cells(RowNum2 + Ci, ColNum1).Value = LineCount - 1
Worksheets(MyLathe).Cells(RowNum2 + Ci, ColNum1 + 1).Value = GearRowCnt
LineCount = LineCount + 1
GearRowCnt = GearRowCnt + 1

'Now Copy & Paste the lines for this gear set seltection
    Worksheets(MyLathe).Select
    Range(Cells(RowNum2 + Ci, ColNum1), Cells(RowNum2 + Ci, ColNum7)).Select
    Selection.Copy
    Worksheets("AllTPI").Select
    ActiveSheet.Range("A" & LineCount - 2).Select
    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
        :=False, Transpose:=False
        
    Ci = Ci + 1 'Increment the inner most loop
    Next Ri  ' This is the PQRiT PM1440GT lever loop return
'    CiMax = Evaluate("Max(" & Ci - 1 & ", " & CiMax & ")") ' Capture the last value of Ci in this loop.
    ' need the max function to avoid problem with Feed Subsituition in to this gear column.
    Ci = 1 'reset this counter for any future loop
    
    Cj = Cj + 1
    Next Rj  ' This is the WXYZ lever loop return
    Cj = 1


    Ck = Ck + 1
    Next Rk  ' This is the NA
    Ck = 1

    Cl = Cl + 1
    Next Rl  ' This is the second NA loop return
    Cl = 1

' Let the User know that something is happening
    Statusinfo = CStr(GearRowCnt - 1)
    Statusinfo = "  Looping -- Gears Completed = " + Statusinfo
    Application.StatusBar = Statusinfo

    'Application.ScreenUpdating = True  'here if needed
    'Application.ScreenUpdating = False  'here if needed


' Let the User know that something is happening
'    Statusinfo = CStr(GearRowCnt - 1)
'    Statusinfo = "  Looping -- Gears Completed = " + Statusinfo
    Application.StatusBar = Statusinfo
    
    Co = Co + 1
    Next Ro  ' This is the C2B Exchange Gear loop return
    Co = 1
    
    Cp = Cp + 1
    Next Rp  ' This is the B-B Exchange Gear loop return
    Cp = 1
' Let the User know that something is happening
    Statusinfo = CStr(GearRowCnt - 1)
    Statusinfo = "  Looping -- Gears Completed  = " + Statusinfo
    Application.StatusBar = Statusinfo

    Cq = Cq + 1
     
    If GearRowCnt >= MaxCnt Then   ' 10000 give the user an opportunity to quit if he puts too many gears in!
    Application.ScreenUpdating = True
        MsgStr = "The # of combinations found is " + CStr(GearRowCnt - 1) + " exceeds " + CStr(MaxCnt) + ". Shall we exit this process?"
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Quit now")
        If YesNoAnswer = vbYes Then
            WFalse = True
        Exit Do    ' See Do WFalse=....
        Else
'        MaxCnt = 8 * MaxCnt
        MaxCnt = IIf(GearRowCnt > MaxCnt * 8, GearRowCnt, MaxCnt * 8)
        End If
    End If
    
    Application.ScreenUpdating = False
    
    Next Rq  ' This is the B2A Gear loop return
    Cq = 1
    
    Cr = Cr + 1
    Next Rr  ' This is the A-A Exchange Gear loop return
    Cr = 1
    
    Cs = Cs + 1
    Next Rs  ' This is the A2Spin Exchange Gear loop return
    Cs = 1
    
    Ct = Ct + 1
    Next Rt  ' This is the Spindle Gear loop return
    Ct = 1
    
    Cu = Cu + 1
    Next Ru  ' This is the Spindle Gear loop return
    Cu = 1
   
    Cv = Cv + 1
    Next Rv  ' This is the Spindle Gear loop return
    Cv = 1
   
'********* Out of alphabetical sequence so that the gear is in the second to last loop
'***********Moved factors of 2, A_D etc, to second most outer loop
    Cn = Cn + 1
    Next Rn  ' This is the A-D knob loop return
    Cn = 1

'********* Out of alphabetical sequence so that the gear is in the last loop
'********* Moved Feed/LeadScrew sequence, column M, order to the outer most loop
    Cm = Cm + 1
    Next Rm  ' This is the Feed knob and lever loop return
    Cm = 1
'********* Moved Feed/LeadScrew sequence order to the outer most loop

WFalse = True ' lets get out of the loop after one trip through
Exit Do ' lets get out of the loop after one trip through
Loop '  Do While condition finished, provides exit for too many gear values via MaxCnt


'Application.ScreenUpdating = True  'If false then the screen does not flash during execution.
' Cleaning up the MyLathe Gear Setting to the top of the pull down menu list
'Worksheets(MyLathe).Cells(30, "I").Value = ""  'Alternative
' Put the pull down menus back to the initial value in the list
Worksheets(MyLathe).Select
Cells(RowNum4, ColNum4 + 0).Value = InputRi(1, 1) '(30,"I")=(30,9)
Cells(RowNum4, ColNum4 + 1).Value = InputRj(1, 1)
Cells(RowNum4, ColNum4 + 2).Value = InputRk(1, 1)
Cells(RowNum4, ColNum4 + 3).Value = InputRl(1, 1)
Cells(RowNum4, ColNum4 + 4).Value = InputRm(1, 1)
Cells(RowNum4, ColNum4 + 5).Value = InputRn(1, 1)
Cells(RowNum4, ColNum4 + 6).Value = InputRo(1, 1)
Cells(RowNum4, ColNum4 + 7).Value = InputRp(1, 1)  '(30,"P")=(30,9+7)
Cells(RowNum4, ColNum4 + 8).Value = InputRq(1, 1)
Cells(RowNum4, ColNum4 + 9).Value = InputRr(1, 1)
Cells(RowNum4, ColNum4 + 10).Value = InputRs(1, 1)
Cells(RowNum4, ColNum4 + 11).Value = InputRt(1, 1) '30,"T")=(30,9+11)
Cells(RowNum4, ColNum4 + 12).Value = InputRu(1, 1)
Cells(RowNum4, ColNum4 + 13).Value = InputRv(1, 1)
    
    
' Insert Row Bottom demarker lines ~ at the end of each set of gears or every few lines
Worksheets("AllTPI").Select
Application.DisplayAlerts = True
Application.ScreenUpdating = True


Dim RnumSpace As String
Dim Rnum As Integer
Dim lRow As Long
Dim lCol As Long

    MsgStr = "If You would like to have eye guiding underlines in the TPI table insert a repeat spacing Integer. example: 5,   0=> No Underlines"
        RnumSpace = InputBox(MsgStr, _
            "Provide underline spacing number", "4")
    If RnumSpace = "False" Or Len(Trim(RnumSpace)) = 0 Then RnumSpace = 4    'This takes care of CANCEL or Null response

Application.ScreenUpdating = False   ' Turns the display off while drawing horizontal lines, saves time.
If RnumSpace <> 0 Then
    'Find the last non-blank cell in TPI column
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    'Find the last non-blank cell in lRow just found
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
Rnum = 2 + RnumSpace
Do While Rnum < GearRowCnt
    With Worksheets("AllTPI").Range(Cells(Rnum, 1), Cells(Rnum, lCol)).Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = 0
    End With
Rnum = Rnum + RnumSpace  ' Cell bottom demarker lines at the end of each set of gears
Loop
Else
End If
Application.ScreenUpdating = True  ' Turns the display back on after drawing horizontal lines

' Let the User know that something is happening
    Statusinfo = CStr(GearRowCnt - 1)
    Statusinfo = "Macro Task Completed-- Total Gears Completed = " + Statusinfo
    Application.StatusBar = Statusinfo

    Application.DisplayAlerts = True
    ' Write the total number of gear rows at the top gear row column title row of table
    Cells(1, 2) = GearRowCnt - 1

End Sub


